# Class TaskSettings

Settings that affect whether a feature source participates in common tasks that are performed on a map.

#### Hierarchy (view full)

- Settings<TaskSettingsProperties>
  - TaskSettings

#####
Index

### Constructors

constructor

### Properties

@eventTypes

### Accessors

enableAdd
enableDelete
enableEditing
enableExport
enableIdentify
enableQuery
enableSearch
enableUpdate
parent
studioSearchSubindexId

### Methods

_getCollectionSetting
_getNestedSettings
_getSerializableProperties
_getSetting
_hasSettingIncludingAncestor
_setParent
_setSetting
_toPropertyDef
assignProperties
assignPropertiesAsync
finishAssignProperties
getDefault
getDefaults
getSerializableProperties
isModified
reset
toJSON

##
Constructors

### constructor

- new TaskSettings(_properties?): TaskSettings

- #### Parameters

  - `Optional`_properties: unknown

  #### Returns TaskSettings

  Inherited from Settings.constructor

##
Properties

### @eventTypes

@eventTypes: SettingsEvents<TaskSettings>

#### Deprecated

Do not directly reference this property. Use EventNames and EventTypes helpers from @arcgis/core/Evented.

Overrides Settings.@eventTypes

##
Accessors

### enableAdd

- get enableAdd(): boolean

- Determines whether the feature source supports adding features. True by default.

  #### Returns boolean

- set enableAdd(value): void

- #### Parameters

  - value: boolean

  #### Returns void

### enableDelete

- get enableDelete(): boolean

- Determines whether the feature source supports deleting features. True by default.

  #### Returns boolean

- set enableDelete(value): void

- #### Parameters

  - value: boolean

  #### Returns void

### enableEditing

- get enableEditing(): boolean

- Determines whether the feature source supports editing features. True by default. Setting this to false will disable adding, updating, and deleting features, regardless of the values of enableAdd, enableUpdate, and enableDelete.

  #### Returns boolean

- set enableEditing(value): void

- #### Parameters

  - value: boolean

  #### Returns void

### enableExport

- get enableExport(): boolean

- Determines whether the feature source is included when exporting the map. True by default.

  #### Returns boolean

- set enableExport(value): void

- #### Parameters

  - value: boolean

  #### Returns void

### enableIdentify

- get enableIdentify(): boolean

- Determines whether the feature source is included when performing an identify operation on the map. True by default.

  #### Returns boolean

- set enableIdentify(value): void

- #### Parameters

  - value: boolean

  #### Returns void

### enableQuery

- get enableQuery(): boolean

- Determines whether the feature source should be available for querying in a query tool. True by default.

  #### Returns boolean

- set enableQuery(value): void

- #### Parameters

  - value: boolean

  #### Returns void

### enableSearch

- get enableSearch(): boolean

- Determines whether the feature source is searched by default when searching a map. True by default.

  #### Returns boolean

- set enableSearch(value): void

- #### Parameters

  - value: boolean

  #### Returns void

### enableUpdate

- get enableUpdate(): boolean

- Determines whether the feature source supports updating features. True by default.

  #### Returns boolean

- set enableUpdate(value): void

- #### Parameters

  - value: boolean

  #### Returns void

### parent

- get parent(): this

- The parent settings that these settings will inherit from.

  #### Returns this

  Inherited from Settings.parent

- set parent(value): void

- #### Parameters

  - value: this

  #### Returns void

  Inherited from Settings.parent

### studioSearchSubindexId

- get studioSearchSubindexId(): string

- Saves the value of the subindex ID that is received back from Studio Search backend when the new layer/subindex is added to the Studio Search App Configuration. Things to note:

  - This setting requires enableSearch to be set to true in order to have any effect.
  - By enabling this setting a new search index will be created in VertiGIS Studio Search Designer.
  - Note that not all sources support VertiGIS Studio Search.
  - Empty by default.

  #### Returns string

- set studioSearchSubindexId(value): void

- #### Parameters

  - value: string

  #### Returns void

##
Methods

### `Protected`_getCollectionSetting

- _getCollectionSetting<T>(setting): Collection<T>

- Gets the value for a setting that represents a collection.

  #### Type Parameters

  - T

  #### Parameters

  - setting: keyof TaskSettings

    The setting name.

  #### Returns Collection<T>

  Inherited from Settings._getCollectionSetting

### `Protected`_getNestedSettings

- _getNestedSettings<T>(setting, factory): T

- Gets a property which is itself an instance of Settings.

  #### Type Parameters

  - T extends Settings<unknown>

  #### Parameters

  - setting: keyof TaskSettings

    The setting name.

  - factory: (() => T)

    A factory for creating the nested settings.

    - - (): T

      - #### Returns T

  Inherited from Settings._getNestedSettings

### `Protected`_getSerializableProperties

- _getSerializableProperties(): PropertyDefs<TaskSettingsProperties>

- The property keys and their metadata that are used to implement serializing and deserializing the class instance.

  #### Returns PropertyDefs<TaskSettingsProperties>

  Overrides Settings._getSerializableProperties

### `Protected`_getSetting

- _getSetting<K>(setting, defaultValue?): TaskSettings[K]

- Gets the value for a setting.

  #### Type Parameters

  - K extends keyof TaskSettings

  #### Parameters

  - setting: K

    The setting name.

  - `Optional` defaultValue: TaskSettings[K]

    The default value if the setting is not explicitly set.

  #### Returns TaskSettings[K]

  Inherited from Settings._getSetting

### `Protected`_hasSettingIncludingAncestor

- _hasSettingIncludingAncestor<K>(setting): boolean

- Determines whether the specified setting has been modified locally or by any parent of the current settings instance.

  #### Type Parameters

  - K extends keyof TaskSettings

  #### Parameters

  - setting: K

    The setting to check.

  #### Returns boolean

  Inherited from Settings._hasSettingIncludingAncestor

### `Protected`_setParent

- _setParent(parent): void

- Sets the parent settings that these settings will inherit from.

  #### Parameters

  - parent: TaskSettings

    The parent settings to inherit from.

  #### Returns void

  Inherited from Settings._setParent

### `Protected`_setSetting

- _setSetting<K>(setting, value): void

- Sets the value for a setting. This will override any inherited value for the setting.

  #### Type Parameters

  - K extends keyof TaskSettings

  #### Parameters

  - setting: K

    The setting name.

  - value: TaskSettings[K]

    The setting value.

  #### Returns void

  Inherited from Settings._setSetting

### `Protected`_toPropertyDef

- _toPropertyDef<T>(def): PropertyDef<T>

- Converts the value to a PropertyDef object.

  #### Type Parameters

  - T

  #### Parameters

  - def: PropertyDefSerializeMode | PropertyDefSerializeMode[] | PropertyDef<T>

    The value to convert.

  #### Returns PropertyDef<T>

  Inherited from Settings._toPropertyDef

### assignProperties

- assignProperties(properties): void

- #### Parameters

  - properties: Partial<unknown>

  #### Returns void

  #### Inherit Doc

  Inherited from Settings.assignProperties

### assignPropertiesAsync

- assignPropertiesAsync(properties): Promise<void>

- #### Parameters

  - properties: Partial<unknown>

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from Settings.assignPropertiesAsync

### finishAssignProperties

- finishAssignProperties(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from Settings.finishAssignProperties

### getDefault

- getDefault<K>(key): unknown

- #### Type Parameters

  - K extends never

  #### Parameters

  - key: K

  #### Returns unknown

  #### Inherit Doc

  Inherited from Settings.getDefault

### getDefaults

- getDefaults(): TaskSettingsProperties

- #### Returns TaskSettingsProperties

  #### Inherit Doc

  Inherited from Settings.getDefaults

### getSerializableProperties

- getSerializableProperties(serializeMode?): PropertyDefs<unknown>

- Returns the serializable properties.

  #### Parameters

  - serializeMode: SerializeMode = "all"

    Optional. If specified, only properties that support the given serialization mode will be returned.

  #### Returns PropertyDefs<unknown>

  Inherited from Settings.getSerializableProperties

### isModified

- isModified(): boolean

- Determines whether the settings have been locally modified in any way.

  #### Returns boolean

  Inherited from Settings.isModified

- isModified(setting): boolean

- Determines whether the specified setting has been locally modified, and is thus overriding any inherited value.

  #### Parameters

  - setting: keyof TaskSettings

    The setting to check.

  #### Returns boolean

  Inherited from Settings.isModified

### reset

- reset(): void

- Removes all local overrides, resetting all settings to their inherited values, if any.

  #### Returns void

  Inherited from Settings.reset

- reset(setting): void

- Removes a local override for a setting and resets it to its inherited value, if any.

  #### Parameters

  - setting: keyof TaskSettings

    The setting to reset.

  #### Returns void

  Inherited from Settings.reset

### toJSON

- toJSON(serializeMode?): TaskSettingsProperties

- #### Parameters

  - serializeMode: SerializeMode = "all"

  #### Returns TaskSettingsProperties

  #### Inherit Doc

  Inherited from Settings.toJSON